define("io.ox/office/presentation/utils/presentationutils",["io.ox/office/tk/utils","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom","gettext!io.ox/office/presentation/main"],function(a,b,c,d){"use strict";var e={};return e.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS=["left","top","width","height","rotation","flipH","flipV"],e.DEFAULT_PLACEHOLDER_TYPE="body",e.TABLE_PLACEHOLDER_TYPE="tbl",e.IMAGE_PLACEHOLDER_TYPE="pic",e.CONTENTBODY="contentbody",e.TITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1},e.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1,subTitle:1},e.ODF_MASTER_READONLY_TYPES={title:1,body:1},e.NO_TEXT_PLACEHOLDER_TYPE={media:1,clipArt:1,chart:1,dgm:1,tbl:1,pic:1},e.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY={media:null,clipArt:"image",chart:null,dgm:null,tbl:"table",pic:"image"},e.PLACEHOLDER_TEMPLATE_TEXTS={body:d("Click to add text"),title:d("Click to add title"),ctrTitle:d("Click to add title"),subTitle:d("Click to add subtitle"),media:d("Media clip"),clipArt:d("Online image"),chart:d("Chart"),dgm:d("Smart Art"),tbl:d("Click to add table"),pic:d("Click to add image"),sldNum:d("Slide Number"),ftr:d("Footer"),dt:d("Date")},e.PLACEHOLDER_TEMPLATE_TEXTS_ODF={body:d("Click to add text"),title:d("Click to add title"),ctrTitle:d("Click to add title"),subTitle:d("Click to add text"),media:d("Media clip"),clipArt:d("Online image"),chart:d("Chart"),dgm:d("Smart Art"),tbl:d("Click to add table"),pic:d("Click to add image"),sldNum:d("Slide Number"),ftr:d("Footer"),dt:d("Date")},e.PLACEHOLDER_TEMPLATE_TEXTS_CLICK={pic:d("Click icon to add image"),tbl:d("Click icon to add table"),chart:d("Click icon to add chart"),dgm:d("Click icon to add smart art graphic"),clipArt:d("Click icon to add clip art"),media:d("Click icon to add media")},e.PLACEHOLDER_TEMPLATE_BUTTONS={contentBody:["picture","table"],body:null,title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},e.PLACEHOLDER_TEMPLATE_BUTTONS_ODF={contentBody:["picture","table"],body:["picture","table"],title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},e.PLACEHOLDER_DRAWING_NAMES={content:d("Content placeholder"),contentv:d("Vertical content placeholder"),text:d("Text placeholder"),textv:d("Vertical text placeholder"),picture:d("Image placeholder"),table:d("Table placeholder")},e.PLACEHOLDER_TEXT_CONTENT=[d("Edit Master text styles"),d("Second level"),d("Third level"),d("Fourth level"),d("Fifth level")],e.PLACEHOLDER_TITLE_CONTENT=d("Click to edit Master title style"),e.DEFAULT_PLACEHOLDER_INDEX=0,e.isPlaceHolderAttributeSet=function(a){return!(!a||!a.presentation||!a.presentation.phType&&!_.isNumber(a.presentation.phIndex))},e.isTitlePlaceHolderAttributeSet=function(a){return!!(a&&a.presentation&&a.presentation.phType&&e.TITLE_PLACEHOLDER_TYPES[a.presentation.phType])},e.isTitleOrSubtitlePlaceHolderAttributeSet=function(a){return!!(a&&a.presentation&&a.presentation.phType&&e.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES[a.presentation.phType])},e.isBodyPlaceHolderAttributeSet=function(a){return!(!(a&&a.presentation&&_.isNumber(a.presentation.phIndex))||a.presentation.phType!==e.DEFAULT_PLACEHOLDER_TYPE&&a.presentation.phType)},e.isTextBodyPlaceHolderAttributeSet=function(a,b){var c=b||!1;return!(c||!a||!a.presentation||!_.isNumber(a.presentation.phIndex)||a.presentation.phType!==e.DEFAULT_PLACEHOLDER_TYPE)},e.isContentBodyPlaceHolderAttributeSet=function(a,b){var c=b||!1;return!(!a||!a.presentation||!_.isNumber(a.presentation.phIndex)&&!c||a.presentation.phType&&(!c||a.presentation.phType!==e.DEFAULT_PLACEHOLDER_TYPE))},e.isPlaceHolderWithoutTextAttributeSet=function(a){return!!(a&&a.presentation&&a.presentation.phType&&e.NO_TEXT_PLACEHOLDER_TYPE[a.presentation.phType])},e.isCustomPromptPlaceHolderAttributeSet=function(a){return!!(a&&a.presentation&&a.presentation.customPrompt)},e.isODFReadOnlyPlaceHolderAttributeSet=function(a){return!!(a&&a.presentation&&a.presentation.phType&&e.ODF_MASTER_READONLY_TYPES[a.presentation.phType])},e.isBodyPlaceHolderAttributeSetWithoutIndex=function(a){return!(!a||!a.presentation||_.isNumber(a.presentation.phIndex)||a.presentation.phType!==e.DEFAULT_PLACEHOLDER_TYPE)},e.isUserModifiedPlaceHolderAttributeSet=function(a){return!!(a&&a.presentation&&a.presentation.userTransformed)},e.isPlaceHolderDrawing=function(a){return e.isPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.getPlaceHolderDrawingType=function(a,c){var d=c||b.getExplicitAttributes(a);return d&&d.presentation&&d.presentation.phType?d.presentation.phType:null},e.getPlaceHolderDrawingIndex=function(a,c){var d=c||b.getExplicitAttributes(a);return d&&d.presentation&&_.isNumber(d.presentation.phIndex)?d.presentation.phIndex:null},e.isTitlePlaceHolderDrawing=function(a){return e.isTitlePlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isTitleOrSubtitlePlaceHolderDrawing=function(a){return e.isTitleOrSubtitlePlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isBodyPlaceHolderDrawing=function(a){return e.isBodyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isTextBodyPlaceHolderDrawing=function(a){return e.isTextBodyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isContentBodyPlaceHolderDrawing=function(a){return e.isContentBodyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isPlaceHolderWithoutTextDrawing=function(a){return e.isPlaceHolderWithoutTextAttributeSet(b.getExplicitAttributes(a))},e.isEmptyPlaceHolderDrawing=function(a){var d=b.getExplicitAttributes(a),f=!1,g=null;return e.isPlaceHolderWithoutTextAttributeSet(d)?"undefined"!==$(a).attr("data-type")&&(g=e.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY[d.presentation.phType],d&&g&&d[g]||(f=!0)):e.isPlaceHolderAttributeSet(d)&&(f=c.isEmptyTextframe(a,{ignoreTemplateText:!0})),f},e.isCustomPromptPlaceHolderDrawing=function(a){return e.isCustomPromptPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isODFReadOnlyPlaceHolderDrawing=function(a){return e.isODFReadOnlyPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.isBodyPlaceHolderWithoutIndexDrawing=function(a){return e.isBodyPlaceHolderAttributeSetWithoutIndex(b.getExplicitAttributes(a))},e.isUserModifiedPlaceHolderDrawing=function(a){return e.isUserModifiedPlaceHolderAttributeSet(b.getExplicitAttributes(a))},e.requiresUserTransformedProperty=function(a){var c=b.getExplicitAttributes(a);return e.isPlaceHolderAttributeSet(c)&&!e.isUserModifiedPlaceHolderAttributeSet(c)},e.getDrawingModelDescriptor=function(d,f){var g=b.getExplicitAttributes(d),h=a.getBooleanOption(f,"useDefaultValues",!0),i=null;return e.isPlaceHolderAttributeSet(g)&&(i={},i.target=c.getTargetContainerId($(d).parent()),i.type=g.presentation.phType,i.index=g.presentation.phIndex,h&&(i.type&&!_.isNumber(i.index)&&(i.index=e.DEFAULT_PLACEHOLDER_INDEX),_.isNumber(i.index)&&!i.type&&(i.type=e.DEFAULT_PLACEHOLDER_TYPE))),i},e.getValidTypeIndexSet=function(b){return b&&b.presentation&&("phType"in b.presentation||"phIndex"in b.presentation)?{type:a.getStringOption(b.presentation,"phType",e.DEFAULT_PLACEHOLDER_TYPE),index:a.getIntegerOption(b.presentation,"phIndex",e.DEFAULT_PLACEHOLDER_INDEX)}:null},e.getPlaceHolderTemplateText=function(a,b){var c=e.getPlaceHolderDrawingType(a),d=b||!1;return!c&&_.isNumber(e.getPlaceHolderDrawingIndex(a))&&(c=e.DEFAULT_PLACEHOLDER_TYPE),c?d?e.PLACEHOLDER_TEMPLATE_TEXTS_ODF[c]:e.PLACEHOLDER_TEMPLATE_TEXTS[c]:null},e.getPlaceHolderTemplateButtonsList=function(a,b){var c=b?e.PLACEHOLDER_TEMPLATE_BUTTONS_ODF:e.PLACEHOLDER_TEMPLATE_BUTTONS;return c[a||"contentBody"]},e.getODFFooterRepresentation=function(a){var b=e.PLACEHOLDER_TEMPLATE_TEXTS_ODF[a];return b?"<"+b+">":""},e.convertAppContentBoxToOperationBox=function(b,c,d){var e=b.getView().getZoomFactor(),f=b.getModel().getSlideById(b.getModel().getActiveSlideId()),g=f.offset(),h=b.getView().getContentRootNode(),i=h.offset(),j=h.scrollLeft(),k=h.scrollTop(),l={},m=!!_.isBoolean(d)&&d;return l.left=a.round((c.left-(g.left-i.left)-j)/e,1),l.top=a.round((c.top-(g.top-i.top)-k)/e,1),l.width=m?c.width:a.round(c.width/e,1),l.height=m?c.height:a.round(c.height/e,1),l.left=a.convertLengthToHmm(l.left,"px"),l.top=a.convertLengthToHmm(l.top,"px"),l.width=a.convertLengthToHmm(l.width,"px"),l.height=a.convertLengthToHmm(l.height,"px"),l.left<0&&(l.left=0),l},e.extendPlaceholderProp=function(a,c,d){if(d&&d.attrs&&d.attrs.drawing){var f=b.getExplicitAttributes(c);if(e.isPlaceHolderAttributeSet(f)){var g=a.getModel().getDrawingStyles().getElementAttributes(c).drawing;_.each(g,function(a,b){b in d.attrs.drawing||!_.contains(e.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS,b)||b in f.drawing||(d.attrs.drawing[b]=a)})}}},e});