define("io.ox/office/spreadsheet/app/drawingcontroller",["io.ox/office/tk/utils","io.ox/office/drawinglayer/view/drawinglabels","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/view/chartcreator","gettext!io.ox/office/spreadsheet/main"],function(a,b,c,d,e){"use strict";function f(f,g,h){function i(b){switch(b){case"sheets":h.yell({type:"warning",message:e("Data references are located on different sheets.")});break;case"directions":h.yell({type:"warning",message:e("Data references are too complex for this operation.")});break;default:a.warn('DrawingController.yellChartDirection(): unknown warning type: "'+b+'"')}return $.Deferred().reject()}function j(){var a=h.getSelectedDrawings();return 1===a.length?a[0]:null}function k(a){var b=j();if(b)return h.getDrawingCollection().getModel(b,{type:a})}function l(a,b,c,d){return h.getSheetModel().createAndApplyOperations(function(e){var f=j(),g=d?$.when(d(e,f)):$.when();return g.done(function(){m(e,a,b,f,c)})},{storeSelection:!0})}function m(b,d,e,f,g){var h=null;switch(e){case c.SET_CHART_LEGEND_ATTRIBUTES:var i=d.getLegendModel(g.axis);h={attrs:i.getUndoAttributeSet(g.attrs)};break;case c.SET_CHART_TITLE_ATTRIBUTES:var j=d.getTitleModel(g.axis);h={axis:g.axis,attrs:j.getUndoAttributeSet(g.attrs)};break;case c.SET_CHART_AXIS_ATTRIBUTES:var k=d.getAxisModel(g.axis);h={axis:g.axis,attrs:k.getUndoAttributeSet(g.attrs)};break;case c.SET_CHART_GRIDLINE_ATTRIBUTES:var l=d.getAxisModel(g.axis).getGrid();h={axis:g.axis,attrs:l.getUndoAttributeSet(g.attrs)};break;case c.CHANGE_DRAWING:h={attrs:d.getUndoAttributeSet(g.attrs)};break;default:return void a.error('generateChartOperation(): unknown operation "'+e+'"')}b.generateDrawingOperation(e,f,h,{undo:!0}),b.generateDrawingOperation(e,f,g)}function n(a){return _.isObject(a)&&_.isArray(a.text.link)?(a.text.link[0]||"").trim():""}function o(a,b,d){return l(a,c.SET_CHART_TITLE_ATTRIBUTES,{axis:b,attrs:d})}function p(a,b,c){return o(a,b,{text:{link:[c]},character:d.getHeadChar(g)})}function q(){var a=h.enterCustomSelectionMode("chartsource",{statusLabel:e("Select source data")});a.done(function(a){var b=a.ranges[0],c=h.getActiveSheet(),e=k("chart"),g=e.getDataSourceInfo();if(g.warn)return d.updateSeries({app:f,sourceRange:b,sourceSheet:c,chartModel:e});var i;return e.isXYType()&&(i=e.isNamesLabel()),d.updateSeries({app:f,sourceRange:b,sourceSheet:c,chartModel:e,axis:g.axis,forceNames:i})})}function r(a){var c=k("chart"),e=b.CHART_TYPE_STYLES[a],g=c.getDataSourceInfo();if(g.warn)return i(g.warn);var h;return c.isXYType()&&(h=c.isNamesLabel()),d.updateSeries({app:f,sourceRange:g.range,sourceSheet:g.sheet,chartModel:c,axis:g.axis,chartData:e,forceNames:h})}function s(a,b){if(!a)return!1;var c=a.getDataSourceInfo();return!c.warn&&(c.axis&&(b=Math.abs(b-1)),1===b?v(a):a.isNamesLabel()||a.getSeriesCount()>1)}function t(a,b){if(!a)return!1;var c=a.getDataSourceInfo();return!c.warn&&(c.axis&&(b=Math.abs(b-1)),1===b?a.isTitleLabel():a.isNamesLabel())}function u(a,b,c){if(!a)return null;var e=a.getDataSourceInfo();if(e.warn)return null;e.axis&&(b=Math.abs(b-1));var g,h;return 1===b?(h=a.isNamesLabel(),g=c):(h=c,g=a.isTitleLabel()),d.updateSeries({app:f,sourceRange:e.range,sourceSheet:e.sheet,chartModel:a,axis:e.axis,forceTitle:g,forceNames:h})}function v(a){if(a.isTitleLabel())return!0;var b=1;return a.isAreaOrLine()&&(b=2),a.getFirstPointsCount()>b}function w(a){var b=0;return a.isAreaOrLine()&&(b=1),a.getSeriesCount()>b}function x(a){var b=a.getDataSourceInfo();if(b.warn)return i(b.warn);var c=a.isNamesLabel(),e=a.isTitleLabel();return d.updateSeries({app:f,sourceRange:b.range,sourceSheet:b.sheet,chartModel:a,axis:1-b.axis,forceTitle:c,forceNames:e})}function y(a,b){function e(b){return b?b.getAxisIdForDrawing(a):a}function f(a){return{line:a?d.getStandardShape(g):d.getNoneShape()}}function h(a,b){return l(a,c.SET_CHART_AXIS_ATTRIBUTES,{axis:e(a),attrs:b})}function i(a,b){return l(a,c.SET_CHART_GRIDLINE_ATTRIBUTES,{axis:e(a),attrs:b})}var j="drawing/chart/axis/"+a+"/";b[j+"model"]={parent:["drawing/chart/valid","drawing/chart/axes/enabled"],get:function(a){return a?a.getAxisModel(e(a)):null}},b[j+"attributes"]={parent:[j+"model","drawing/chart/valid"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){return h(this.getParentValue(1),a)}},b[j+"labels/visible"]={parent:[j+"attributes","drawing/chart/valid"],get:function(a){return _.isObject(a)&&a.axis.label===!0&&this.areParentsEnabled()},set:function(a){return h(this.getParentValue(1),{axis:{label:a}})}},b[j+"line/visible"]={parent:[j+"attributes","drawing/chart/valid"],get:function(a){return _.isObject(a)&&"none"!==a.line.type},set:function(a){return h(this.getParentValue(1),f(a))}},b[j+"grid/model"]={parent:j+"model",get:function(a){return a?a.getGrid():null}},b[j+"grid/attributes"]={parent:[j+"grid/model","drawing/chart/valid"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){return i(this.getParentValue(1),a)}},b[j+"grid/visible"]={parent:[j+"grid/attributes","drawing/chart/valid"],get:function(a){return _.isObject(a)&&"none"!==a.line.type},set:function(a){return i(this.getParentValue(1),f(a))}},b[j+"title/model"]={parent:j+"model",get:function(a){return a?a.getTitle():null}},b[j+"title/attributes"]={parent:[j+"title/model","drawing/chart/valid"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){var b=this.getParentValue(1);return o(b,e(b),a)}},b[j+"title/text"]={parent:[j+"title/attributes","drawing/chart/valid"],get:function(a){return n(a)},set:function(a){var b=this.getParentValue(1);return p(b,e(b),a)}},b[j+"title/delete"]={parent:[j+"title/text","drawing/chart/valid"],enable:function(){return this.getValue().length>0},set:function(){var a=this.getParentValue(1);return p(a,e(a),"")}}}function z(){var a={};a["chart/insert"]={parent:"drawing/insert/enable",enable:function(){var a=h.getSelectedRanges();return 1===a.length&&!h.getSheetModel().isSingleCellInRange(a[0])},set:function(a){return d.createChart(f,b.CHART_TYPE_STYLES[a])}},a["drawing/chart"]={parent:"drawing/operation",enable:function(){return _.isObject(this.getValue())},get:function(){return k("chart")}},a["drawing/chart/valid"]={parent:"drawing/chart",enable:function(a){return a.isSupported()}},a["drawing/chartlabels"]={parent:"drawing/chart/valid",get:function(){return h.getChartLabelsMenu().isVisible()},set:function(a){h.getChartLabelsMenu().toggle(a)}},a["drawing/chartexchange"]={parent:"drawing/chart/valid",enable:w,set:function(){return x(this.getParentValue())}},a["drawing/chartfirstcol"]={parent:"drawing/chart/valid",enable:function(a){return s(a,0)},get:function(a){return t(a,0)},set:function(a){return u(this.getParentValue(),0,a)}},a["drawing/chartfirstrow"]={parent:"drawing/chart/valid",enable:function(a){return s(a,1)},get:function(a){return t(a,1)},set:function(a){return u(this.getParentValue(),1,a)}},a["drawing/charttype"]={parent:"drawing/chart/valid",get:function(a){return a?a.getChartTypeForGui():null},set:r},a["drawing/chart/attributes"]={parent:"drawing/chart/valid",get:function(a){return a?a.getMergedAttributeSet(!0):null}},a["drawing/chartvarycolor"]={parent:["drawing/chart/valid","drawing/chart/attributes"],enable:function(a){return a.isVaryColorEnabled()},get:function(a){return a?a.isVaryColor():null},set:function(a){return this.getParentValue().changeVaryColors(a)}},a["drawing/chartdatalabel"]={parent:"drawing/chart/valid",get:function(a){return a?!_.isEmpty(a.getDataLabel()):null},set:function(a){return this.getParentValue().setDataLabel(a)}},a["drawing/chartcolorset"]={parent:"drawing/chart/valid",get:function(a){return a?a.getColorSet():null},set:function(a){return this.getParentValue().changeColorSet(a)}},a["drawing/chartstyleset"]={parent:"drawing/chart/valid",get:function(a){return a?a.getStyleSet():null},set:function(a){return this.getParentValue().changeStyleSet(a)}},a["drawing/chartdatasource"]={parent:"drawing/chart/valid"},a["drawing/chartsource"]={parent:"drawing/chart/valid",get:function(){return B},set:q},a["drawing/chartlegend/pos"]={parent:"drawing/chart/valid",get:function(a){return a?a.getLegendModel().getMergedAttributeSet(!0).legend.pos:null},set:function(a){return l(this.getParentValue(),c.SET_CHART_LEGEND_ATTRIBUTES,{attrs:{legend:{pos:a}}})}},a["drawing/chart/axes/enabled"]={parent:"drawing/chart/valid",enable:function(a){return a.isAxesEnabled()}},y("x",a),y("y",a),a["drawing/chart/title/model"]={parent:"drawing/chart/valid",get:function(a){return a?a.getTitleModel("main"):null}},a["drawing/chart/title/attributes"]={parent:["drawing/chart/title/model","drawing/chart/valid"],get:function(a){return a?a.getMergedAttributeSet(!0):null},set:function(a){return o(this.getParentValue(1),"main",a)}},a["drawing/chart/title/text"]={parent:["drawing/chart/title/attributes","drawing/chart/valid"],get:function(a){return n(a)},set:function(a){return p(this.getParentValue(1),"main",a)}},a["drawing/chart/title/delete"]={parent:["drawing/chart/title/text","drawing/chart/valid"],enable:function(){return this.getValue().length>0},set:function(){return p(this.getParentValue(1),"main","")}},A.registerDefinitions(a)}var A=this,B=!1;z(),this.registerDestructor(function(){A=f=g=h=null})}return f});