define("io.ox/office/spreadsheet/model/formula/parser/tokens",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(a,b,c){"use strict";var d=b.ErrorCode,e=b.Interval,f=b.Address,g=b.Range,h=b.Range3D,i=b.RangeArray,j=b.IntervalArray,k=b.Range3DArray,l=b.MoveDescriptor,m=c.Scalar,n=c.CellRef,o=c.SheetRef,p=_.makeExtendable(function(a){this._type=a});p.prototype.getType=function(){return this._type},p.prototype.isType=function(a){return a===this._type},p.prototype.matchesType=function(a){return a.test(this._type)},p.prototype.getText=function(){return a.error("BaseToken.getText(): missing implementation"),""},p.prototype.debugText=function(){return a.error("BaseToken.debugText(): missing implementation"),""},p.prototype.toString=function(){var a=this.debugText();return this._type+(a?"["+a+"]":"")},p.prototype.resolveDeletedSheet=function(){return null},p.prototype.resolveRenamedSheet=function(){return null},p.prototype.resolveRelabeledName=function(){return null},p.prototype.resolveMovedCells=function(){return null},p.prototype.resolveCutPasteCells=function(){return null};var q=p.extend({constructor:function(a,b){p.call(this,a),this._text=b}});q.prototype.getValue=function(){return this._text},q.prototype.setValue=function(a){return this._text!==a&&(this._text=a,!0)},q.prototype.appendValue=function(a){return 0!==a.length&&(this._text+=a,!0)},q.prototype.getText=function(){return this._text},q.prototype.debugText=function(){return this._text};var r=p.extend({constructor:function(a){p.call(this,"op"),this._value=a}});r.prototype.getValue=function(){return this._value},r.prototype.getText=function(a){return a.getOperatorName(this._value)||"?"},r.prototype.debugText=function(){return this._value};var s=p.extend({constructor:function(){p.call(this,"sep")}});s.prototype.getText=function(a){return a.SEP},s.prototype.debugText=_.constant("");var t=q.extend({constructor:function(a){q.call(this,a?"open":"close",a?"(":")")}});t.prototype.debugText=_.constant("");var u=p.extend({constructor:function(a){p.call(this,"lit"),this._value=a}});u.prototype.getValue=function(){return this._value},u.prototype.setValue=function(a){return this._value!==a&&(this._value=a,!0)},u.prototype.getText=function(a){return a.formatScalar(this._value)},u.prototype.debugText=function(){return m.toString(this._value)};var v=p.extend({constructor:function(a){p.call(this,"mat"),this._matrix=a}});v.prototype.getMatrix=function(){return this._matrix},v.prototype.getText=function(a){var b=a.MAT_OPEN;return this._matrix.forEach(function(c,d,e){e>0?b+=a.MAT_COL:d>0&&(b+=a.MAT_ROW),b+=a.formatScalar(c)}),b+a.MAT_CLOSE},v.prototype.debugText=function(){return this._matrix.toString()};var w=p.extend({constructor:function(a){p.call(this,"func"),this._value=a}});w.prototype.getValue=function(){return this._value},w.prototype.getText=function(a){return a.getFunctionName(this._value)||this._value.toUpperCase()},w.prototype.debugText=function(){return this._value};var x=p.extend({constructor:function(a,b,c,d,e){if(p.call(this,a),this._docModel=b,this._sheet1Ref=c,this._sheet2Ref=d,this._extDocRef=e,c&&c.valid()&&d&&d.valid()&&d.sheet<c.sheet){var f=d.abs;d.abs=c.abs,c.abs=f;var g=d.sheet;d.sheet=c.sheet,c.sheet=g}}});x.prototype._isOwnSheetRef=function(a){return this.isOwnDoc()&&_.isObject(a)},x.prototype._resolveSheetRefs=function(b){return{s1:a.getOption(b,"sheet1Ref",this._sheet1Ref),s2:a.getOption(b,"sheet2Ref",this._sheet2Ref)}},x.prototype._resolveSheetInterval=function(b){if(!this.isOwnDoc())return null;var c=this._sheet1Ref?this._sheet1Ref.sheet:a.getIntegerOption(b,"refSheet",null),d=this._sheet2Ref?this._sheet2Ref.sheet:c;return"number"==typeof c&&c>=0&&"number"==typeof d&&d>=0?e.create(c,d):null},x.prototype.isOwnDoc=function(){return!this._extDocRef},x.prototype.hasSheetRef=function(){return!!this._sheet1Ref},x.prototype.hasSheetError=function(){return!!this._sheet1Ref&&!this._sheet1Ref.valid()||!!this._sheet2Ref&&!this._sheet2Ref.valid()},x.prototype.refreshSheets=function(){var a=this._isOwnSheetRef(this._sheet1Ref)&&this._sheet1Ref.refresh(this._docModel),b=this._isOwnSheetRef(this._sheet2Ref)&&this._sheet2Ref.refresh(this._docModel);return a||b},x.prototype.transformSheet=function(a,b){var c=this._isOwnSheetRef(this._sheet1Ref)&&this._sheet1Ref.transform(a,b),d=this._isOwnSheetRef(this._sheet2Ref)&&this._sheet2Ref.transform(a,b);return c||d},x.prototype.debugSheetPrefix=function(){var a=null===this._extDocRef?"":"["+this._extDocRef+"]";return this._sheet1Ref&&(a+=this._sheet1Ref.toString()),this._sheet1Ref&&this._sheet2Ref&&!this._sheet1Ref.equals(this._sheet2Ref)&&(a+=":"+this._sheet2Ref.toString()),a?a+"!":""},x.prototype.resolveDeletedSheet=function(a,b,c){if(!this.isOwnDoc())return null;var d=this._sheet1Ref?this._resolveSheetInterval({refSheet:c}):null;return d?d.single()?b===d.first?this.getText(a,{sheet1Ref:new o(-1,!0)}):null:b===d.first?this.getText(a,{sheet1Ref:new o(d.first+1,this._sheet1Ref.abs),sheet2Ref:new o(d.last,this._sheet2Ref.abs)}):b===d.last?this.getText(a,{sheet1Ref:new o(d.first,this._sheet1Ref.abs),sheet2Ref:new o(d.last-1,this._sheet2Ref.abs)}):null:null},x.prototype.resolveRenamedSheet=function(a,b,c){if(!this.isOwnDoc())return null;var d=this._sheet1Ref&&this._sheet1Ref.sheet===b?new o(c,this._sheet1Ref.abs):this._sheet1Ref,e=this._sheet2Ref&&this._sheet2Ref.sheet===b?new o(c,this._sheet2Ref.abs):this._sheet2Ref;return d!==this._sheet1Ref||e!==this._sheet2Ref?this.getText(a,{sheet1Ref:d,sheet2Ref:e}):null};var y=x.extend({constructor:function(a,b,c,d,e){if(x.call(this,"ref",a,d,e,null),this._cell1Ref=b,this._cell2Ref=c,b&&c&&c.col<b.col){var f=c.absCol;c.absCol=b.absCol,b.absCol=f;var g=c.col;c.col=b.col,b.col=g}if(this._cell1Ref&&this._cell2Ref&&this._cell2Ref.row<this._cell1Ref.row){var h=c.absRow;c.absRow=b.absRow,b.absRow=h;var i=c.row;c.row=b.row,b.row=i}}});y.prototype._isSingleRelative=function(a){return!this._cell1Ref.isAbs(a)&&(!this._cell2Ref||!this._cell2Ref.isAbs(a)&&this._cell1Ref.getIndex(a)===this._cell2Ref.getIndex(a))},y.prototype._resolveCellRefs=function(b){var c=a.getOption(b,"refAddress",f.A1),d=a.getOption(b,"targetAddress",f.A1);if(c.equals(d))return{r1:this._cell1Ref,r2:this._cell2Ref};var e={r1:this._cell1Ref?this._cell1Ref.clone():null,r2:this._cell2Ref?this._cell2Ref.clone():null},g=a.getBooleanOption(b,"wrapReferences",!1);return e.r1&&!e.r1.relocate(this._docModel,c,d,g)&&(e.r1=null),e.r1&&e.r2&&!e.r2.relocate(this._docModel,c,d,g)&&(e.r1=e.r2=null),e},y.prototype.getRange3D=function(a){var b=this._resolveSheetInterval(a);if(!b)return null;var c=this._resolveCellRefs(a);if(!c.r1)return null;var d=c.r1.toAddress(),e=c.r2?c.r2.toAddress():null;return e?h.createFromAddresses(d,e,b.first,b.last):h.createFromAddress(d,b.first,b.last)},y.prototype.getExpandedRanges=function(b,c,d){function f(a,c,d,e){var f=a.getIndex(d);if(a.isAbs(d))return f;var g=(e?c.start:c.end).get(d);return f+g-b.get(d)}function g(a,b){var c=f(this._cell1Ref,a,b,!0);this._cell2Ref&&(c=Math.min(c,f(this._cell2Ref,a,b,!0)));var d=f(this._cell1Ref,a,b,!1);this._cell2Ref&&(d=Math.max(d,f(this._cell2Ref,a,b,!1)));var g=this._docModel.getMaxIndex(b);if(i){c<0?(c+=g+1,d+=g+1):c>g&&(c-=g+1,d-=g+1);var h=new j;return d<=g?h.push(new e(c,d)):this._isSingleRelative(b)?(h.push(new e(0,d-g-1)),h.push(new e(c,g))):h.push(new e(0,g)),h}return c=Math.max(c,0),d=Math.min(d,g),c<=d?new j(new e(c,d)):null}if(!this._cell1Ref)return null;var h=this._resolveSheetInterval(d);if(!h)return null;var i=a.getBooleanOption(d,"wrapReferences",!1);return k.map(c,function(a){var b=g.call(this,a,!0),c=b?g.call(this,a,!1):null;return c?k.createFromIntervals(b,c,h.first,h.last):null},this)},y.prototype.hasRelCol=function(){return!!this._cell1Ref&&(!this._cell1Ref.absCol||!!this._cell2Ref&&!this._cell2Ref.absCol)},y.prototype.hasRelRow=function(){return!!this._cell1Ref&&(!this._cell1Ref.absRow||!!this._cell2Ref&&!this._cell2Ref.absRow)},y.prototype.setRange=function(a){var b=!1;return this._cell1Ref||(this._cell1Ref=new n(0,0,!0,!0),b=!0),this._cell2Ref||a.single()||(this._cell2Ref=this._cell1Ref.clone(),b=!0),this._cell1Ref.col!==a.start[0]&&(this._cell1Ref.col=a.start[0],b=!0),this._cell1Ref.row!==a.start[1]&&(this._cell1Ref.row=a.start[1],b=!0),this._cell2Ref&&(this._cell2Ref.col!==a.end[0]&&(this._cell2Ref.col=a.end[0],b=!0),this._cell2Ref.row!==a.end[1]&&(this._cell2Ref.row=a.end[1],b=!0),this._cell1Ref.equals(this._cell2Ref)&&(this._cell2Ref=null,b=!0)),b},y.prototype.relocateRange=function(a,b,c){return!(!this._cell1Ref||a.equals(b))&&(this._cell1Ref.relocate(this._docModel,a,b,c)?(this._cell2Ref&&!this._cell2Ref.relocate(this._docModel,a,b,c)&&(this._cell1Ref=this._cell2Ref=null),!0):(this._cell1Ref=this._cell2Ref=null,!0))},y.prototype.getText=function(b,c){var d=this._resolveSheetRefs(c),e=this._resolveCellRefs(c),g=a.getOption(c,"targetAddress",f.A1);return b.formatReference(this._docModel,g,d.s1,d.s2,e.r1,e.r2)},y.prototype.debugText=function(){var a=this.debugSheetPrefix();return a+=this._cell1Ref?this._cell1Ref:d.REF,a+=this._cell1Ref&&this._cell2Ref?":"+this._cell2Ref:""},y.prototype.resolveMovedCells=function(b,c,d,e){var h=this.getRange3D(e);if(!h||!h.isSheet(c))return null;var i=a.getBooleanOption(e,"freezeRelRefs",!1),j=h.toRange(),k=j.clone();if(d.every(function(a){if(i){var b=!this._cell1Ref.isAbs(a.columns),c=!this._cell2Ref||!this._cell2Ref.isAbs(a.columns);if(b&&c)return k;if(b){var d=a.transformAddress(k.end);return k=d?g.createFromAddresses(k.start,d):null}if(c&&this._cell2Ref){var e=a.transformAddress(k.start);return k=e?g.createFromAddresses(e,k.end):null}}return k=a.transformRange(k)},this),k&&k.equals(j))return null;var l=k&&n.create(k.start,this._cell1Ref.absCol,this._cell1Ref.absRow),m=k&&this._cell2Ref&&n.create(k.end,this._cell2Ref.absCol,this._cell2Ref.absRow),o=a.getOption(e,"targetAddress",f.A1);return b.formatReference(this._docModel,o,this._sheet1Ref,this._sheet2Ref,l,m)},y.prototype.resolveCutPasteCells=function(a,b,c,d){var e=d.sheet,f=this._cell1Ref&&this._cell2Ref,h=this.getRange3D(d),j=b.start[0]===c.start[0],k=b.start[1]===c.start[1],l=!!j||!k&&null,m=b.start.get(!l)<c.start.get(!l),o=h.toRange(),p=o.overlaps(c),q=null,r=null,s=null;if(!h||!h.isSheet(e))return null;if(f?b.contains(new g(this._cell1Ref.toAddress(),this._cell2Ref.toAddress())):this._cell1Ref&&b.containsAddress(this._cell1Ref.toAddress())){var t=this._cell1Ref?this._cell1Ref.clone():null,u=this._cell2Ref?this._cell2Ref.clone():null;return this.relocateRange(b.start,c.start,!1),r=this._cell1Ref?this._cell1Ref.clone():null,s=this._cell2Ref?this._cell2Ref.clone():null,this._cell1Ref=t,this._cell2Ref=u,a.formatReference(this._docModel,c.start,this._sheet1Ref,this._sheet2Ref,r,s)}if(f&&this._cell1Ref.getIndex(l)>=b.start.get(l)&&this._cell2Ref.getIndex(l)<=b.end.get(l)){if(!j&&!k)return null;var v=new i(o).difference(b).first(),w=b.intersect(o);if(!w)return null;var x=this._cell1Ref.col,y=this._cell1Ref.row,z=this._cell2Ref.col,A=this._cell2Ref.row,B=b.contains(l?o.headerRow():o.leadingCol()),C=b.contains(l?o.footerRow():o.trailingCol()),D=c.contains(l?o.headerRow():o.leadingCol()),E=c.contains(l?o.footerRow():o.trailingCol()),F=w.start[0]-b.start[0],G=w.start[1]-b.start[1],H=b.cols()-F-w.cols(),I=b.rows()-G-w.rows();return B?E?(x=v.start[0],y=v.start[1],z=c.start[0]+F+w.cols()-1,A=c.start[1]+G+w.rows()-1):!p&&m||(x=F>0||!m?c.start[0]+F:v.start[0],y=G>0||!m?c.start[1]+G:v.start[1],z=Math.max(w.cols(),v.end[0]),A=Math.max(w.rows(),v.end[1])):C&&(D?(x=Math.min(v.start[0],c.start[0]+F),y=Math.min(v.start[1],c.start[1]+G),z=H>0&&m?c.start[0]+F+w.cols()-1:v.end[0],A=I>0&&m?c.start[1]+G+w.rows()-1:v.end[1]):(p||m)&&(x=Math.min(v.start[0],c.start[0]+F),y=Math.min(v.start[1],c.start[1]+G),z=H>0||m?c.start[0]+F+w.cols()-1:v.end[0],A=I>0||m?c.start[1]+G+w.rows()-1:v.end[1])),q=g.create(x,y,z,A),q&&q.equals(o)?null:(r=q&&n.create(q.start,this._cell1Ref.absCol,this._cell1Ref.absRow),s=q&&this._cell2Ref&&n.create(q.end,this._cell2Ref.absCol,this._cell2Ref.absRow),a.formatReference(this._docModel,c.start,this._sheet1Ref,this._sheet2Ref,r,s))}return null};var z=x.extend({constructor:function(a,b,c,d){x.call(this,"name",a,c,null,d),this._value=b}});z.prototype._getNameModelFromSheet=function(a,b){var c="number"==typeof a?this._docModel.getSheetModel(a):null;return c?c.getNameCollection().getName(b):null},z.prototype._resolveNameModel=function(a,b){return this.isOwnDoc()?this._sheet1Ref?this._getNameModelFromSheet(this._sheet1Ref.sheet,a):0===this._extDocRef?this._docModel.getNameCollection().getName(a):this._getNameModelFromSheet(b,a)||this._docModel.getNameCollection().getName(a):null},z.prototype._resolveTableModel=function(a){if(!this.isOwnDoc())return null;if(this._sheet1Ref){var b=this._sheet1Ref.sheet,c="number"==typeof b?this._docModel.getSheetModel(b):null;return c?c.getTableCollection().getTable(a):null}return this._docModel.getTable(a)},z.prototype.getValue=function(){return this._value},z.prototype.resolveNameModel=function(a){return this._resolveNameModel(this._value,a)},z.prototype.resolveTableModel=function(){return this._resolveTableModel(this._value)},z.prototype.getText=function(b,c){var d=this._resolveSheetRefs(c),e=a.getStringOption(c,"label",this._value);return b.formatName(this._docModel,this._extDocRef,d.s1,e)},z.prototype.debugText=function(){return this.debugSheetPrefix()+this._value},z.prototype.resolveRelabeledName=function(a,b,c,d,e){if(c.toLowerCase()!==this._value.toLowerCase())return null;var f=this._resolveNameModel(d,e);if(f){var g="number"==typeof b?this._docModel.getSheetModel(b):null;return g!==f.getSheetModel()?null:this.getText(a,{label:d})}};var A=x.extend({constructor:function(a,b,c){x.call(this,"macro",a,c,null,null),this._value=b}});A.prototype.getValue=function(){return this._value},A.prototype.getText=function(b,c){var d=this._resolveSheetRefs(c),e=a.getStringOption(c,"label",this._value);return b.formatMacro(this._docModel,this._extDocRef,d.s1,e)},A.prototype.debugText=function(){return this.debugSheetPrefix()+this._value};var B=p.extend({constructor:function(b,c,d){p.call(this,"table"),this._docModel=b,this._tableName=c,this._regionKey=a.getStringOption(d,"regionKey",null),this._regionKeys=this._regionKey?this._regionKey.split(","):null,this._col1Name=a.getStringOption(d,"col1Name",null),this._col2Name=this._col1Name?a.getStringOption(d,"col2Name",null):null,this._openWs=a.getBooleanOption(d,"openWs",!1),this._closeWs=a.getBooleanOption(d,"closeWs",!1),this._sepWs=a.getBooleanOption(d,"sepWs",!1)}});B.prototype._resolveRangeData=function(a){var b=this.resolveTableModel();if(!b)return null;var c=this.getRegionKey(),d=!a&&"ROW"===c,e=d?b.getRange():b.getRegionRange(c,a);if(!e)return null;var f=b.getRange();if(this._col1Name){var g=b.findColumnByName(this._col1Name);if(null!==g)if(this._col2Name){var h=b.findColumnByName(this._col2Name);f=null!==h?f.colRange(Math.min(g,h),Math.abs(g-h)+1):null}else f=f.colRange(g);else f=null}return f?{tableModel:b,tableRange:e.intersect(f)}:null},B.prototype.getTableName=function(){return this._tableName},B.prototype.getRegionKey=function(){return this._regionKey||"DATA"},B.prototype.hasColumnRange=function(){return!!this._col1Name},B.prototype.resolveTableModel=function(){return this._docModel.getTable(this._tableName)},B.prototype.getRange3D=function(a){var b=this._resolveRangeData(a);if(!b)return null;var c=b.tableModel.getSheetModel().getIndex();return h.createFromRange(b.tableRange,c)},B.prototype.getText=function(b,c){function d(a){return a?" ":""}var e=a.getStringOption(c,"tableName",this._tableName),f=this._openWs||this._closeWs;if(!this._regionKeys&&!this._col1Name)return e+(b.UI||"ooxml"!==b.REF_SYNTAX?"":"["+d(f)+"]");var g=this._regionKeys&&1===this._regionKeys.length?this._regionKeys[0]:null,h=[];if(b.UI&&"ROW"===g){var i="";this._col2Name?i="["+b.encodeTableColumn(this._col1Name)+"]:["+b.encodeTableColumn(this._col2Name)+"]":this._col1Name&&(i=b.isSimpleTableColumn(this._col1Name)?this._col1Name:"["+b.encodeTableColumn(this._col1Name)+"]"),h.push("@"+i)}else!g||f||this._col1Name?this._regionKeys||!this._col1Name||this._col2Name||f||/^\s|\s$/.test(this._col1Name)?(this._regionKeys&&this._regionKeys.forEach(function(a){h.push("["+b.getTableRegionName(a)+"]")}),this._col2Name?h.push("["+b.encodeTableColumn(this._col1Name)+"]:["+b.encodeTableColumn(this._col2Name)+"]"):this._col1Name&&h.push("["+b.encodeTableColumn(this._col1Name)+"]")):h.push(b.encodeTableColumn(this._col1Name)):h.push(b.getTableRegionName(g));var j=!0;if(b.UI&&a.getBooleanOption(c,"unqualifiedTables",!1)&&this._col1Name&&!this._col2Name&&(!this._regionKeys||"ROW"===g)){var k=this.resolveTableModel(),l=a.getIntegerOption(c,"refSheet",null);if(k&&k.getSheetModel().getIndex()===l){var m=a.getOption(c,"targetAddress",null);j=!m||!k.containsCell(m)}}return(j?e:"")+"["+d(this._openWs)+h.join(b.SEP+d(this._sepWs))+d(this._closeWs)+"]"},B.prototype.debugText=function(){var a=this._tableName;return this._regionKeys&&(a+=this._regionKeys.map(function(a){return"[#"+a+"]"})),this._col1Name&&(a+="["+this._col1Name+"]"),this._col2Name&&(a+=":["+this._col2Name+"]"),a},B.prototype.resolveDeletedSheet=function(a,b){var c=this.resolveTableModel();return c&&c.getSheetModel().getIndex()!==b?null:a.getErrorName(d.REF)},B.prototype.resolveRenamedSheet=function(a,b,c,e){if(!e)return null;var f=this.resolveTableModel();if(!f)return a.getErrorName(d.REF);var g=e[f.getName()];return g?this.getText(a,{tableName:g}):null},B.prototype.resolveMovedCells=function(a,b,c){var e=this._resolveRangeData(null);if(!e)return a.getErrorName(d.REF);if(b!==e.tableModel.getSheetModel().getIndex())return null;var f=e.tableRange;if(!l.transformRange(f,c))return a.getErrorName(d.REF);if(this.hasColumnRange()){var g=l.transformRange(f.leadingCol(),c),h=l.transformRange(f.trailingCol(),c);if(!g||!h)return a.getErrorName(d.REF)}return null};var C={FixedToken:q,OperatorToken:r,SeparatorToken:s,ParenthesisToken:t,LiteralToken:u,MatrixToken:v,FunctionToken:w,SheetRefToken:x,ReferenceToken:y,NameToken:z,MacroToken:A,TableToken:B};return C});