define("io.ox/office/spreadsheet/model/formula/tokenarray",["io.ox/office/tk/utils","io.ox/office/tk/container/valueset","io.ox/office/tk/container/valuemap","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(a,b,c,d,e,f){"use strict";function g(a,c){this._docModel=a.getDocModel(),this._sheetModel=a===this._docModel?null:a,this._changeHandlers=null,this._allTokens=[],this._sheet3dTokens=[],this._refTokens=[],this._nameTokens=[],this._tokenTypeSet={},this._wrapReferences="name"===c,this._freezeRelRefs="name"===c,this._detectCircular="cell"===c,this._unqualifiedTables="cell"===c,this._compileDesc=null,this._resultCache=null,this._interpreting=new b("key()")}var h=d.Address,i=d.RangeArray,j=d.Range3DArray,k=e.CellRef,l=e.SheetRef,m=f.SeparatorToken,n=f.ParenthesisToken,o=f.ReferenceToken,p=f.NameToken;return g.prototype._registerToken=function(a){this._tokenTypeSet[a.getType()]=!0,a.hasSheetRef&&a.hasSheetRef()&&this._sheet3dTokens.push(a),a instanceof o&&this._refTokens.push(a),a instanceof p&&this._nameTokens.push(a)},g.prototype._invokeChangeHandlers=function(a,b){this._compileDesc=null,this.clearResultCache(),this._changeHandlers&&this._changeHandlers.forEach(function(c){c.call(this,a,b)},this)},g.prototype._resolveChangedFormula=function(a,b){var c=this._docModel.getFormulaGrammar(a),d="",e="";return this._allTokens.forEach(function(a){var f=a.getText(c),g=b.call(this,a,c);d+=f,e+=null===g?f:g},this),d===e?null:{old:d,new:e}},g.prototype._resolveRefSheet=function(b){return this._sheetModel?this._sheetModel.getIndex():a.getIntegerOption(b,"refSheet",null)},g.prototype._extendWithOwnOptions=function(a){return _.extend({wrapReferences:this._wrapReferences},a,{refSheet:this._resolveRefSheet(a),detectCircular:this._detectCircular,unqualifiedTables:this._unqualifiedTables})},g.prototype._compileTokens=function(a){return this._docModel.getFormulaCompiler().compileTokens(a)},g.prototype._isInterpreting=function(a){return this._interpreting.has(a)},g.prototype._lockInterpreting=function(a,b){try{return this._interpreting.insert(a),b.call(this)}finally{this._interpreting.remove(a)}},g.prototype.getDocModel=function(){return this._docModel},g.prototype.getSheetModel=function(){return this._sheetModel},g.prototype.empty=function(){return 0===this._allTokens.length},g.prototype.hasToken=function(a){return a in this._tokenTypeSet},g.prototype.hasRefTokens=function(){return this.hasToken("ref")||this.hasToken("name")||this.hasToken("table")},g.prototype.hasSheet3dTokens=function(){return this._sheet3dTokens.length>0},g.prototype.getFormula=function(a,b){var c=this._docModel.getFormulaGrammar(a),d=this._extendWithOwnOptions(b);return this._allTokens.reduce(function(a,b){return a+b.getText(c,d)},"")},g.prototype.resolveStringList=function(){var a=[],b="";return this._allTokens.every(function(c){switch(c.getType()){case"lit":return b+="L",a.push(c.getValue()),_.isString(_.last(a));case"sep":return b+=",",!0;case"ws":return!0;default:return b+="I",!1}}),/^L(,L)*$/.test(b)?a:null},g.prototype.resolveRangeList=function(b){var c=a.getOption(b,"targetAddress",h.A1),d=new j;if(this._isInterpreting(c))return d;var e=a.getStringOption(b,"resolveNames",null),f=e?this.hasRefTokens():this.hasToken("ref");if(!f)return d;b=this._extendWithOwnOptions(b);var g="",i=this._allTokens.every(function(a){switch(a.getType()){case"ref":var f=a.getRange3D(b);return!(!f||!f.singleSheet())&&(d.push(f),g+="R",!0);case"name":var i=e?a.resolveNameModel(b.refSheet):null;if(!i)return!1;var k=_.clone(b);k.refAddress=h.A1;var l=this._lockInterpreting(c,function(){var a=i.getTokenArray();switch(e){case"simple":return a.resolveRangeList(k);case"interpret":var b=a.interpretFormula("ref",k);return b.value instanceof j?b.value:null;default:return null}});return!(!l||l.empty())&&(d.append(l),g+="R",!0);case"table":var m=e?a.getRange3D(c):null;return!!m&&(d.push(m),g+="R",!0);case"open":return g+="<",!0;case"close":return g+=">",!0;case"sep":return g+=",",!0;case"ws":return!0;default:return!1}},this);return i&&/^(R(,R)*|<R(,R)*>)$/.test(g)?d:d.clear()},g.prototype.extractRanges=function(b){var c=a.getOption(b,"targetAddress",h.A1),d=[];if(d.circular=!1,this._isInterpreting(c))return d.circular=!0,d;var e=a.getBooleanOption(b,"resolveNames",!1),f=e?this.hasRefTokens():this.hasToken("ref");return f?(b=this._extendWithOwnOptions(b),this._allTokens.forEach(function(a,f){switch(a.getType()){case"ref":var g=a.getRange3D(b);g&&d.push({range:g,index:f,type:"ref"});break;case"name":var i=e?a.resolveNameModel(b.refSheet):null;if(!i)return;var j=_.clone(b);j.refAddress=h.A1;var k=this._lockInterpreting(c,function(){return i.getTokenArray().extractRanges(j)});k.forEach(function(a){d.push({range:a.range,index:f,type:"name"})}),d.circular=d.circular||k.circular;break;case"table":var l=e?a.getRange3D(c):null;l&&d.push({range:l,index:f,type:"table"})}},this),d):d},g.prototype.resolveOperation=function(b,c,d,e){var f=this._resolveRefSheet(),g=function(){switch(c.type){case"deleteSheet":return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(b,function(a,b){return a.resolveDeletedSheet(b,c.sheet,f)}):null;case"renameSheet":return 0!==this._sheet3dTokens.length||this.hasToken("table")?this._resolveChangedFormula(b,function(a,b){return a.resolveRenamedSheet(b,c.sheet,c.sheetName,c.tableNames)}):null;case"relabelName":return 0===this._nameTokens.length?null:this._resolveChangedFormula(b,function(a,b){return a.resolveRelabeledName(b,c.sheet,c.oldLabel,c.newLabel,f)});case"moveCells":if(!this.hasToken("ref")&&!this.hasToken("table"))return null;var d={refSheet:f,freezeRelRefs:this._freezeRelRefs};return c.relocate&&(d.refAddress=c.relocate.from,d.targetAddress=c.relocate.to),this._resolveChangedFormula(b,function(a,b){return a.resolveMovedCells(b,c.sheet,c.moveDescs,d)});case"cutPaste":if(!this.hasToken("ref")&&!this.hasToken("table"))return null;var e={refSheet:f,sheet:c.sourceSheet};return this._resolveChangedFormula(b,function(a,b){return a.resolveCutPasteCells(b,c.sourceRange,c.targetRange,e)})}return a.error('TokenArray.resolveOperation(): unknown operation type "'+c.type+'"'),null}.call(this);return g&&d.call(e,g.new,g.old),this},g.prototype.registerChangeHandler=function(a){return(this._changeHandlers||(this._changeHandlers=[])).push(a),this},g.prototype.unregisterChangeHandler=function(a){return this._changeHandlers&&(this._changeHandlers=_.without(this._changeHandlers,a)),this},g.prototype.setTokens=function(a){return this.empty()&&0===a.length?this:(this._allTokens=a.slice(),this._refTokens=[],this._sheet3dTokens=[],this._tokenTypeSet={},this._allTokens.forEach(this._registerToken,this),this._invokeChangeHandlers(null),this)},g.prototype.clearTokens=function(){return this.setTokens([])},g.prototype.parseFormula=function(b,c,d){d=this._extendWithOwnOptions(d);var e=this._docModel.getFormulaParser(),f=e.parseFormula(b,c,d),g=_.pluck(f,"token");if(a.getBooleanOption(d,"autoCorrect",!1)){var h=this._compileTokens(g);if(!h.error)for(var i=0;i<h.missingClose;i+=1)g.push(new n(!1))}return this.setTokens(g),f},g.prototype.refreshAfterImport=function(a){return this.hasToken("bad")?this.parseFormula("op",this.getFormula("op"),a):this._sheet3dTokens.length>0&&(this._sheet3dTokens.forEach(function(a){a.refreshSheets()}),this._compileDesc=null,this.clearResultCache()),this},g.prototype.modifyToken=function(a,b,c,d){var e=this._allTokens[a];return e&&e.isType(b)&&c.call(d,e,a)&&this._invokeChangeHandlers(e,a),this},g.prototype.appendToken=function(a){return this._allTokens.push(a),this._registerToken(a),this._invokeChangeHandlers(a,this._allTokens.length-1),this},g.prototype.appendAddress=function(b,c){var d=a.getBooleanOption(c,"abs",!1),e=k.create(b,d,d),f=a.getIntegerOption(c,"sheet"),g="number"==typeof f?new l(f,!0):null;return this.appendToken(new o(this._docModel,e,null,g))},g.prototype.appendRange=function(b,c){var d=this._docModel.isColRange(b),e=this._docModel.isRowRange(b),f=a.getBooleanOption(c,"abs",!1),g=k.create(b.start,f||e,f||d&&!e),h=b.single()?null:k.create(b.end,f||e,f||d&&!e),i=a.getIntegerOption(c,"sheet"),j="number"==typeof i?new l(i,!0):null;return this.appendToken(new o(this._docModel,g,h,j))},g.prototype.appendRangeList=function(b,c){var d=b.length>1&&a.getBooleanOption(c,"parentheses",!1);return d&&this.appendToken(new n(!0)),b.forEach(function(a,b){b>0&&this.appendToken(new m),this.appendRange(a,c)},this),d&&this.appendToken(new n(!1)),this},g.prototype.relocateRanges=function(a,b){if(a.equals(b))return!1;var c=!1;return this._refTokens.forEach(function(d){d.relocateRange(a,b,this._wrapReferences)&&(c=!0)},this),c&&this._invokeChangeHandlers(null),c},g.prototype.transformSheet=function(a,b){if(b===a)return!1;var c=!1;return this._sheet3dTokens.forEach(function(d){d.transformSheet(a,b)&&(c=!0)},this),c&&this._invokeChangeHandlers(null),c},g.prototype.compileFormula=function(){return this._compileDesc||(this._compileDesc=this._compileTokens(this._allTokens))},g.prototype.getDependencies=function(a,c,f){var g={depRanges:new j,rootRanges:new j,nameSet:new b("getUid()"),tableSet:new b("getUid()"),missingNames:{},missingFuncs:{},recalc:null,circular:!1},k=this.compileFormula();if(k.error)return g;var l=c instanceof h?c:null;if(this._isInterpreting(l||a))return g.circular=!0,g;_.extend(g.missingFuncs,k.missingFuncs),g.recalc=k.root.recalc,f=this._extendWithOwnOptions(f);var m=l?_.extend({},f,{refAddress:a,targetAddress:l}):null,n=l?null:i.get(c),o=function b(i){var k=i.token;if(k.isType("ref")){if(m){var o=k.getRange3D(m);return o?new j(o):null}return k.getExpandedRanges(a,n,f)}if(k.isType("name")){var p=k.resolveNameModel(f.refSheet);if(!p)return g.missingNames[d.getNameKey(k.getValue())]=!0,null;var q=this._lockInterpreting(l||a,function(){return p.getTokenArray().getDependencies(h.A1,c,f)});return g.depRanges.append(q.depRanges),g.nameSet.insert(p),g.nameSet.merge(q.nameSet),g.tableSet.merge(q.tableSet),_.extend(g.missingNames,q.missingNames),_.extend(g.missingFuncs,q.missingFuncs),g.recalc=e.getRecalcMode(g.recalc,q.recalc),g.circular=g.circular||q.circular,q.rootRanges}if(k.isType("table")){var r=k.resolveTableModel();if(!r)return null;g.tableSet.insert(r);var s=k.getRange3D(l);return s?new j(s):null}if(i.operands&&i.signature){var t=new j;return i.signature.forEach(function(a,c){var d=b.call(this,i.operands[c]);switch(a.depSpec){case"pass":t.append(d);break;case"skip":break;default:g.depRanges.append(d)}},this),t}return null}.call(this,k.root);return g.rootRanges.append(o),g},g.prototype.interpretFormula=function(b,d){function f(){return i.interpretTokens(b,g.root,d)}var g=this.compileFormula(),i=this._docModel.getFormulaInterpreter();if(g.error)return i.createErrorResult(b,g.error);var j=a.getOption(d,"targetAddress",h.A1);if(this._isInterpreting(j))return i.createWarnResult(b,e.CIRCULAR_ERROR);d=this._extendWithOwnOptions(d);var k=d.cacheResult&&"always"!==g.root.recalc,l=k?this._resultCache||(this._resultCache=new c):null,m=function(){if(!l)return null;var a=this.hasToken("name"),b=a||g.root.relColRef,c=b&&d.refAddress?d.refAddress[0]:0,e=b?j[0]:0,f=a||g.root.relRowRef,i=f&&d.refAddress?d.refAddress[1]:0,k=f?j[1]:0;return h.key(c,i)+":"+h.key(e,k)}.call(this);return this._lockInterpreting(j,function(){return l?l.getOrCreate(m,f):f()})},g.prototype.clearResultCache=function(){return this._resultCache=null,this},g});