define("io.ox/office/spreadsheet/model/operationgenerator",["io.ox/office/tk/utils","io.ox/office/tk/container/valuemap","io.ox/office/editframework/utils/border","io.ox/office/editframework/model/operationgenerator","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils"],function(a,b,c,d,e,f){"use strict";var g=d.extend({constructor:function(c,e){d.call(this,c,e),this._autoStyles=c.getCellAutoStyles(),this._styleIdCache=new b,this._cacheHits=0,this._cacheMisses=0,this._sheet=a.getIntegerOption(e,"sheet",0)}});return g.prototype._getCachedStyleId=function(a,b){var c=b?this._styleIdCache.get(b):null;if(!c)return null;var d=c.get(a,null);return null!==d&&(this._cacheHits+=1),d},g.prototype._setCachedStyleId=function(a,c,d){d&&(this._styleIdCache.getOrConstruct(d,b).insert(a,c),this._cacheMisses+=1)},g.prototype.getSheetIndex=function(){return this._sheet},g.prototype.setSheetIndex=function(a){return this._sheet=a,this},g.prototype.generateSheetOperation=function(a,b,c){return b=_.extend({sheet:this._sheet},b),this.generateOperation(a,b,c)},g.prototype.generateIntervalOperation=function(a,b,c,d){return c=_.extend({start:b.first},c),(b.first<b.last||d&&d.complete)&&(c.end=b.last),this.generateSheetOperation(a,c,d)},g.prototype.generateCellOperation=function(a,b,c,d){return c=_.extend({start:b.toJSON()},c),this.generateSheetOperation(a,c,d)},g.prototype.generateRangeOperation=function(a,b,c,d){return c=_.extend({start:b.start.toJSON()},c),(!b.single()||d&&d.complete)&&(c.end=b.end.toJSON()),this.generateSheetOperation(a,c,d)},g.prototype.generateRangesOperation=function(a,b,c,d){var e=d&&d.complete;return b=b.map(function(a){var b={start:a.start.toJSON()};return!e&&a.single()||(b.end=a.end.toJSON()),b}),c=_.extend({ranges:b},c),this.generateSheetOperation(a,c,d)},g.prototype.generateTableOperation=function(a,b,c,d){return b.length>0&&(c=_.extend({table:b},c)),this.generateSheetOperation(a,c,d)},g.prototype.generateDrawingOperation=function(a,b,c,d){return c=_.extend({start:[this._sheet].concat(b)},c),this.generateOperation(a,c,d)},g.prototype.generateMoveCellsOperation=function(a,b,c){return this.generateRangeOperation(e.MOVE_CELLS,a,{dir:b.toJSON()},c)},g.prototype.generateMergeCellsOperation=function(a,b,c){return this.generateRangeOperation(e.MERGE_CELLS,a,{type:b.toJSON()},c)},g.prototype.generateMoveDrawingOperation=function(a,b,c){return this.generateDrawingOperation(e.MOVE_DRAWING,a,{to:[this._sheet].concat(b)},c)},g.prototype.isDefaultStyleId=function(a){return this._autoStyles.isDefaultStyleId(a)},g.prototype.areEqualStyleIds=function(a,b){return this._autoStyles.areEqualStyleIds(a,b)},g.prototype.generateAutoStyle=function(b,c){if(!("s"in c||"a"in c||"format"in c))return b;var d=this._getCachedStyleId(b,c.cacheKey);if(null!==d)return d;if(d="string"==typeof c.s?c.s:b,_.isObject(c.a)||"format"in c){var e=a.getFunctionOption(c,"processAttributes");d=this._autoStyles.generateAutoStyleOperation(this,d,c,e)}return this._setCachedStyleId(b,d,c.cacheKey),d},g.prototype.generateInsertedAutoStyle=function(a,b,d){function e(a,b,d){var e=a[b],f=a[d];return e&&f&&c.isEqual(e,f)}function g(a,b){var d=j[a],e=k[b];return d&&e&&c.isEqual(d,e)?d:null}if(this.areEqualStyleIds(a,b))return a;var h=a+"\n"+b,i=this._getCachedStyleId(a,h);if(null!==i)return i;var j=this._autoStyles.getBorderMap(a),k=this._autoStyles.getBorderMap(b);if(_.isEmpty(j)&&_.isEmpty(k))return a;var l={},m=f.getOuterBorderKey(!d,!0);l[f.getBorderName(m)]=g(m,m);var n=f.getOuterBorderKey(!d,!1);l[f.getBorderName(n)]=g(n,n);var o=f.getOuterBorderKey(d,!0),p=f.getOuterBorderKey(d,!1),q=g(p,o),r=q&&(e(j,o,p)||e(k,o,p));return l[f.getBorderName(o)]=l[f.getBorderName(p)]=r?q:null,this.generateAutoStyle(a,{a:{cell:l},cacheKey:h})},g.prototype.createBorderContents=function(){function a(a,b,d){var e=b.cell,g=a.cell;_.each("tblrdu",function(a){var b=f.getBorderName(a);if(b in g){var h=e[b],i=g[b];c.isVisibleBorder(i)||c.isVisibleBorder(h)&&!c.isEqual(h,d[b])||delete g[b]}})}function b(b,g){function h(b,c){return a(b,c,k)}var i={},j={},k={},l=0;return b.forEach(function(a){var b=a.key,c=i[b]||(i[b]={});_.extend(c,a)}),_.each(i,function(a,b){var g=f.getBorderName(b),h=e[b];a.border?(j[g]=a.border,l|=h*d[a.cacheType]):a.keepBorder&&(j[g]=c.NONE,k[g]=a.keepBorder,l|=h*d.clear)}),{a:{cell:j},cacheKey:g+":"+l,processAttributes:h}}var d={outer:1,inner:2,clear:3},e={t:1,b:4,l:16,r:64};return b}(),g.prototype.createVisibleBorderContents=function(){function a(a,b){var d=b.cell,e=a.cell;_.each("tblrdu",function(a){var b=f.getBorderName(a);if(b in e){var g=d[b],h=e[b];c.isVisibleBorder(g)?(h=_.extend({},g,h),e[b]=c.isVisibleBorder(h)?h:c.NONE):delete e[b]}})}function b(b,c,e){var g={},h=0;return b.forEach(function(a){_.each(a.keys,function(a){g[f.getBorderName(a)]=c,h|=d[a]})}),{a:{cell:g},cacheKey:e+":"+h,processAttributes:a}}var d={t:1,b:2,l:4,r:8,d:16,u:32};return b}(),g.prototype.logCacheUsage=f.isLoggingActive()?function(){var a=this._cacheHits+this._cacheMisses;a>0&&(f.log("style cache hits: "+this._cacheHits+" ("+Math.round(this._cacheHits/a*100)+"%)"),f.log("style cache miss: "+this._cacheMisses+" ("+Math.round(this._cacheMisses/a*100)+"%)"))}:_.noop,g});